'''
Created on 25 Jan 2011

@author: Simon Wilshin, swilshin@rvc.ac.uk

Contains information about the nerve blocking condition used on the animal 
(which legs and what 'block' was applied (for if say saline was used).
'''

from os.path import join as osjoin
from yaml import load as yamlload

from baseData import UnsampledBaseData

class BandageConditionData(UnsampledBaseData):
    '''
    Contains information about a bandaged legs
    '''
    def __init__(self, workingDirectory, analysisDirectory, metaData):
        UnsampledBaseData.__init__(self, workingDirectory, analysisDirectory, metaData)
        self.bandagedLegs=metaData["bandagedLegs"]

def getSampleBandageConditionData():
    workingDir = osjoin("..","sampleData")    
    analysisDir = osjoin("..","sampleAnalysis","dataContainers")
    metaDataFile = osjoin("..",'sampleYAML','dataContainers','bandageConditionSample.yaml')
    stream = file(metaDataFile, 'r')
    metaData=yamlload(stream)
    stream.close()
    return(BandageConditionData(workingDir,analysisDir,metaData['bandages']))

if __name__=='__main__':
    '''
    Runs a test using the sample data (which is contained wholly in the YAML in this case)
    '''
    print "Processing sample bandage data"
    sampleBandageConditionData=getSampleBandageConditionData()
    print sampleBandageConditionData.bandagedLegs