'''
Created on 8 Mar 2011

@author: Simon Wilshin, swilshin@rvc.ac.uk

Data objects encapsulating information about a gait transition.
At present this class contains only one piece of information, 
the gait transition in question.
'''

from os.path import join as osjoin
from yaml import load as yamlload

from baseData import UnsampledBaseData

class GaitTransitionData(UnsampledBaseData):
    '''
    Contains information about a single compliant substrate assumed to be 
    omnipresent throughout a trial.
    '''
    
    def __init__(self, workingDirectory, analysisDirectory, metaData):
        UnsampledBaseData.__init__(self, workingDirectory, analysisDirectory, metaData)
        self.transitionType=metaData["transitionType"]
        
def getSampleGaitTransitionData():
    workingDir = osjoin("..","sampleData")    
    analysisDir = osjoin("..","sampleAnalysis","dataContainers")
    metaDataFile = osjoin("..",'sampleYAML','dataContainers','gaitTransitionSample.yaml')
    stream = file(metaDataFile, 'r')
    metaData=yamlload(stream)
    stream.close()
    return(GaitTransitionData(workingDir,analysisDir,metaData['gaitTransition']))

if __name__=='__main__':
    '''
    Runs a test using the sample data (which is contained wholly in the YAML in this case)
    '''
    print "Processing sample gait transition data"
    sampleGaitTransitionData=getSampleGaitTransitionData()
    print "Gait Transition: ", sampleGaitTransitionData.transitionType, "."