'''
Created on 15 Feb 2011

@author: Simon Wilshin, swilshin@rvc.ac.uk

Contains information about the Huntingsdon disease diagnosis of an animal.
'''

from os.path import join as osjoin
from yaml import load as yamlload

from baseData import UnsampledBaseData


class HuntingdonsStatusData(UnsampledBaseData):
    '''
    Contains information about the Huntingsdon disease diagnosis of an animal. 
    '''
    
    def __init__(self, workingDirectory, analysisDirectory, metaData):
        UnsampledBaseData.__init__(self, workingDirectory, analysisDirectory, metaData)
        self.huntingdonsStatus=metaData["huntingdonsStatus"]
        
def getSampleHuntingdonsStatusData():
    workingDir = osjoin("..","sampleData")    
    analysisDir = osjoin("..","sampleAnalysis","dataContainers")
    metaDataFile = osjoin("..",'sampleYAML','dataContainers','huntingdonsStatusDataSample.yaml')
    stream = file(metaDataFile, 'r')
    metaData=yamlload(stream)
    stream.close()
    return(HuntingdonsStatusData(workingDir,analysisDir,metaData['huntingdonsStatus']))

if __name__=='__main__':
    '''
    Runs a test using the sample data (which is contained wholly in the YAML in this case)
    '''
    print "Processing sample nerve block data"
    sampleHuntingdonsStatusData=getSampleHuntingdonsStatusData()
    print "Huntingdon's Status: ", sampleHuntingdonsStatusData.huntingdonsStatus
