#This is an R script for dog data for Michelle SICB abstract 2013. The hypothesis suggested by Simon is that at trotting speeds, trot will become more like walk on rough terrain due to steep sided bowl.

# set working directory
# Move R to the directory with roughGaitsMichelle.csv
# setwd ('/Users/Michelle/spencelab/code/python/smlStrideAnalyse/src')
library(lattice)

# Import csv data file
dat <- read.csv('roughGaitsMichelle.csv')

# Add a column with 'projections' - from the calcs by Simon
dat$ProjTrot <- (((
                   (dat$Phi3+pi)%%(2*pi)
                    -
                   (dat$Phi1+pi)%%(2*pi) 
                    -
                   2*pi
                  )%%(4*pi))/2)-pi
dat$ProjGall <- sign((dat$Phi1+pi)%%(2*pi)+(dat$Phi2+pi)%%(2*pi)+(dat$Phi3+pi)%%(2*pi)-3*pi)*(
				 ((dat$Phi1+pi)%%(2*pi)+(dat$Phi2+pi)%%(4*pi))/2-pi
				 )
# Just trot data pulled out
#trot <- dat[dat$Gait.Type=="Trot",]
# gallop <- dat[dat$Gait.Type=="Gallop",]

# Calculate a mean of the projected distance by dog and terrain type - just numbers to look at, not for plotting necessary
#agdattrot <- aggregate(trot$ProjTrot,by=list(trot$Terrain.Type,trot$Dog),FUN=mean)
# agdatgal <- aggregate(gallop$ProjGall,by=list(gallop$Terrain.Type,gallop$Dog),FUN=mean)

# Adding columns of converted projected distance - converted from rad to % of cycle
# dat$ProjTrotStr <- ((dat$ProjTrot)/(2*pi))*100
# dat$ProjGalltStr <- ((dat$ProjGall)/(2*pi))*100

# Export modified csv to file...
#write.csv (dat, file="/Users/Michelle/RESEARCH/data/roughGaitsSICB/PROJroughGaitsMichelle.csv")
write.csv (dat, file="PROJroughGaitsMichelle.csv")


# Save the following plot to file as a pdf
# pdf(file="/Users/Michelle/RESEARCH/data/roughGaitsSICB/projdensplt.pdf")

# Create a density plot of these projected distances by dog and terrain type
# dp <- densityplot(~ProjTrot | Dog*Terrain.Type, data=trot, auto.key=list, xlab="Projected distance (rad)")
# print(dp)
# dev.off()


# Another alternative plot, where flat and rough data are plotted on the same subplots in different colors:
# densityplot(~Proj | Dog, data=trot, groups=Terrain.Type, auto.key=list(columns=1), xlab="Projected distance (rad)")

# And another alternate version where the individual points are not plotted:
# densityplot(~Proj | Dog, data=trot, groups=Terrain.Type, auto.key=list(columns=1), xlab="Projected distance",plot.points=FALSE)

#Need to install this library: 
#library(lme4)
# Here's some stuff for linear mixed effects models and anova tests - see MichelleSICBnotes.txt for full explanation:
# LMER FOR MODEL:
# proj.model = lmer(Proj~Terrain.Type + Speed + (1|Dog), data=trot)

# LMER FOR NULL
# proj.null = lmer(Proj~Speed + (1|Dog),data=trot)

# ANOVA TO COMPARE:
# anova(proj.null,proj.model)

