# This script contains a for-loop that cycles through the rois and stride numbers to assign consecutive groups
# of stride group numbers
from csv import reader
from csv import writer
from scipy.stats.kde import gaussian_kde
import numpy as n
from numpy import append, array, nan, ones_like, hstack

# cd /mnt/hgfs/Michelle/RESEARCH/data/roughGaits_newanalysisforpaper/

def labelgrps():
	f=open("PROJroughGaitsWALKMichelleFILTERED.csv","r")
	# reader is from a csv module which handles csv files.
	r=reader(f)
	# To the object 'header' it assigns the first row (I think by default 'next' is row, not column)
	header = r.next()
	# This renames the first element of header (i.e. the first column title) to StrideNum, as it's blank from the R script
	header[0] = 'StrideNum'
	# This adds another string to the header object, called StrideGroupNum - essentially adding another column header
	header = append(header, "StrideGroupNum")
	# Creates the object dat, assigns it to the array of data from the csv, which is r
	dat = array([row for row in r])

	# creates object roinum and assigns it to all the rows where the header is roiNum (so just the column roiNum), and data type stored as floats
	roinum=array(dat[:,header=="roiNum"],dtype=float)
	# creates object stridenum and assigns it to all the rows where the header is StrideNum (so just the column StrideNum), and data type stored as floats
	stridenum=array(dat[:,header=="StrideNum"],dtype=float)
	# Create a new object 'stridegroupnum' full of nans, same shape as stridenum
	stridegroupnum = nan*ones_like(stridenum)

	i=0
	# FIRST STRIDE IS PART OF A NEW STRIDE GROUP
	stridegroupnum[0]=i
	# Previous roi is set at start to the first element of roinum for the first loop
	prevroi = roinum[0]
	# Previous stride is set at start to the first element of stridenum for the first loop
	prevstride = stridenum[0]
	# the strideparams here is a cheat to get round the enumerate bit - think you need same number of objects outside (so j and strideparams) as inside (roinum and stridenum)
	# So then strideparams is made equal to roi and stri
	# The for-loop -- for the bracket to be true, both sides of the 'and' have to be true. But the 'not' means that if the bracket is true, i.e. that you're in the same
	# roi group and the next stridenumber is consecutive, the commands in the if statement won't be carried out - that is, stridegroupnum will continue as the same number as 
	# previously. If either side of the 'and' is false, so if the stidenum isn't the previousstridenum +1, or if the roinum isn't the previous roinum +1, the stridegroupnum
	# changes, so as to indicate that we're looking at the next group of consecutive strides.
	# At the end of the loop before it's exited, prevroi and prevstride have to be reassigned to the 'current' roi and stri of the loop, so that when the loop goes 
	# round again, it's not just comparing it to the first element of roinum and stridenum every time.  
	for j, strideparams in enumerate(zip(roinum[1:],stridenum[1:])):
		roi, stri = strideparams
		if not (prevroi == roi and prevstride +1 == stri): 
			i = i+1
		stridegroupnum[j+1] = i
		prevroi = roi
		prevstride = stri
		
	# Here use hstack to stick the 'stridegroupnum' data (column) to the big 'dat' dataset..
	dat = hstack([dat,stridegroupnum])
	wf = open ("strPROJroughGaitsWALKMichelleFILTERED.csv","wb")
	wr = writer(wf)
	wr.writerow(header)
	wr.writerows(dat)
	wf.close()

    
if __name__ == "__main__":
    labelgrps()