'''
Created on 25 May 2011

@author: swilshin

TODO: Add switches (e.g. input arguments) to this script so that you can run it first to process the data, then run it again with a switch to export data.

E.g., to process the data, do

cd /mnt/hgfs/Michelle/spencelab/code/python/smlStrideAnalyse/src
ipython --pylab
run -i roughGaits/roughGaits.py

When analysis done, can do

run -i roughGaits/roughGaits.py -export

This will pickup the -export request, NOT analysis the data, and export a nice csv to the analysis dir.

EXAMPLES:
1. see dogGaitTrans/dogGaitTrans.py for optoin parsing + gogle
2. see dogGaitTrrans/phaseDiffs.py for loading saving objects.
MAKE MEETING WITH SIMON TO DO PROJECTIONS IN IMUDATA (in dataContainers): -- DONE
src/

To get imudata object out for one subject & one trial.
imud = experiment['Caesar']['roicaesar01'].children[3]

'''

import pylab
import numpy as np
import csv
from yaml import load as yamlload
from os.path import join as osjoin
#from csv import writer
from scipy import nanmean
from mDInterpret import loadMD
from experimentTree import ExperimentTree as Experiment
from optparse import OptionParser
import subprocess
from roughGaits.labelstridegroups import labelgrps
from roughGaits.filterwalkspds import filterspds

parser = OptionParser()
parser.add_option("-e","--export", dest="export", default=False, action="store_true",help="Export data to a csv file")
parser.add_option("-w","--walks", dest="walks", default=False, action="store_true",help="Export walk raw IMU data to a csv file")
(options, args) = parser.parse_args()

if options.export is not False:
    print "The export option seems to have worked, doing stuff now.."
    rGMFile = open ('roughGaitsMichelle.csv', 'wb')
    rGMWriter = csv.writer(rGMFile, delimiter=',')
    labs = ["Dog","Gait Type","Terrain Type", "roiNum","Speed", "StrideDur", "StrideFreq","StrideLen","StrideDutyFactor","Phi1","Phi2","Phi3"]
    rGMWriter.writerow(labs)

    walkFile = open ('roughGaitsWalks.csv', 'wb')
    walkWriter = csv.writer(walkFile, delimiter=',')
    wlabs = ["Dog","Gait Type","Terrain Type", "roiNum","Leg","Time","AccX","AccY","AccZ","GyroX","GyroY","GyroZ"]
    walkWriter.writerow(wlabs)
    for subject in experiment:
        name = subject.iD
        for trial in subject:
            print "Exporting stride data for %s %s" % (name,trial['roiNum'])
            for strsp,strd,strf,strl,strdf,relstrph in zip(trial['strideSpeeds'],trial['strideDur'], \
                trial['strideFreq'],trial['strideLen'],trial['strideDutyFactor'],trial['relativeStridePhases']):
                rGMWriter.writerow([name]+[trial['trialType']]+[trial['terrainType']] + 
                    [trial['roiNum']]+list(strsp)+list(strd)+list(strf)+list(strl)+list(strdf)+list(relstrph))
            if options.walks is not False:
                if trial['trialType']=='Walk':
                    print "Exporting raw walk imu data for %s %s" % (name,trial['roiNum'])
                    for leg in ['FL','FR','BL','BR']:
                        print "  Leg " + leg
                        for ind in range(trial[leg+"Acc"].shape[0]):
                            walkWriter.writerow([name]+[trial['trialType']]+[trial['terrainType']] + 
                            [trial['roiNum']]+[leg]+[trial[leg+"Acc"].time[ind]]+list(trial[leg+"Acc"][ind,:])+list(trial[leg+"Gyro"][ind,:]))
                            # trial["FLAcc"].time[ind]
    rGMFile.close()
    walkFile.close()
    # Process with R script
    print "Projecting with R script."
    subprocess.call(['/usr/local/bin/Rscript','roughGaits/RscriptSICB.r'])
    print "Filtering speeds."
    filterspds()
    print "Labeling groups."
    labelgrps()
    print "Running stats."
    subprocess.call(['/usr/local/bin/Rscript','roughGaits/stats_plots_forpaper_roughgaits.R'])
else:
    print "No options selected, starting data processing..."

# If plotting etc. do that -- DONE IN R FOR NOW

# If not doing anything else, assume doing main processing
    #expPathNoYML = ["..","..","..","..","gaitterrain","roughGaits"]
    #expPath = ["..","..","..","..","..","RESEARCH","data","roughGaits","roughGaitsPlugins.yaml"]
    # testing spence mac: ../../data/roughGaits/roughGaitsPluginsReduced.yaml
    # gives error on export - presumably because doesn't have all data. try full:
    #expPath = ["..","..","..","..","data","roughGaits","roughGaitsPluginsReduced.yaml"]
    # all data?
    #expPath = ["/zfstank","storage","storage","work","roughGaits","fromMichelle20160803","redoMichelleLatestDataMyCode","roughGaitsPlugins.yaml"]
    #/zfstank/storage/storage/work/roughGaits/fromMichelle20160803/redoMichelleLatestDataMyCode/roughGaitsPlugins.yaml
    expPath = ["..","..","..","..","data","roughGaitsFinal","roughGaitsPlugins.yaml"]
    #expPath = ["..","..","..","..","data","roughGaitsFinal","roughGaitsPluginsOliver13.yaml"]
    metaData = loadMD(expPath)
    experiment = Experiment(osjoin(*expPath[:-1]),metaData)
